#!/usr/bin/python
#
# s1 -- csound-based sampler
# Copyright (c) 1999 Eric S. Tiedemann
# Released under the GPL (version 2 or later; see file COPYING)

import sys
import os
import string
import tempfile

ourorc = '''

; s1 sampler engine

	sr=44100
	kr=441
	ksmps=100
	nchnls=1

	instr 1
inum  	notnum
ivel  	veloc
ifqc  	cpsmidi
iamp  	ampmidi inum*500
ifn	table inum-1, 1
	print ifn

asig	loscil iamp, 100, ifn
	out asig
	endin
'''

s1f = open(sys.argv[1])
s1i = s1f.read()
s1f.close()

s1 = eval(s1i)

nf = 2
sfiles = {}
fns = {}

for k in s1.keys():
  f = s1[k]
  if (not fns.has_key(f)):
    sfiles[nf] = f
    fns[f] = nf
    nf = nf + 1

tabf = tempfile.mktemp()

tab = open(tabf, 'w')

# prints the table
for x in range(1,129):
  try: f = s1[x]
  except: f = s1.values()[0]
  tab.write(`fns[f]` + "\n")

tab.close()

orcf = tempfile.mktemp()
orc = open(orcf, 'w')
orc.write(ourorc)
orc.close()

scof = tempfile.mktemp()

sco = open(scof, 'w')

# prints the .sco file
sco.write(('f1 0 128 -23 "%s"' % tabf) + "\n")
for i in range(2,nf):
  sco.write("f%d 0 0 1 \"%s\" 0 0 0\n" % (i, sfiles[i]))
sco.write("i0 0 36000\n")

sco.close()

os.system("csound " + string.join(sys.argv[2:], ' ') + " %s %s" % (orcf, scof))

os.unlink(orcf)
os.unlink(tabf)
os.unlink(scof)

sys.exit(0)
